#!/usr/bin/env bash

# local source config
PROXY="192.168.98.1:1080"
SOURCE_BIN_PATH="${INSTALL_PATH}/bin"
SOURCE_ETC_PATH="${INSTALL_PATH}/etc"
SOURCE_LOGS_PATH="${INSTALL_PATH}/logs"
mkdir -p ${SOURCE_LOGS_PATH}
SOURCE_TMP_PATH="${INSTALL_PATH}/tmp"
mkdir -p ${SOURCE_TMP_PATH}

SOURCE_SYSTEMD_PATH="${SOURCE_ETC_PATH}/systemd"
SOURCE_SYSTEMD_TEMPLATE_PATH="${SOURCE_SYSTEMD_PATH}/templates"
SOURCE_SYSTEMD_PRODUCE_PATH="${SOURCE_SYSTEMD_PATH}/produce"
SOURCE_SSL_PATH="${SOURCE_ETC_PATH}/ssl"
SOURCE_CALICO_ETC_PATH="${SOURCE_ETC_PATH}/calico"
SOURCE_CALICO_BIN_PATH="${SOURCE_BIN_PATH}/calico"

SOURCE_KUBE_DNS_PATH="${SOURCE_ETC_PATH}/kube-dns"

# remote kube config
KUBE_VERSION="v1.10.7"
KUBE_HOSTNAME_SUFFIX=".kube"
KUBE_PROTOCOL="https"
KUBE_ETC_PATH="/etc/kubernetes"
KUBE_SSL_PATH="${KUBE_ETC_PATH}/ssl"
KUBE_SYSTEMD_PATH="/usr/lib/systemd/system"
KUBE_POD_NETWORK_CIDR="10.10.0.0/12"

KUBE_SERVICE_NETWORK_CIDR="192.168.22.0/24"
# 此处 KUBERNETES_IP 需要根据 KUBE_SERVICE_CLUSTER_IP_RANGE 手动计算
KUBE_SERVICE_KUBERNETES_IP="192.168.22.1"
# dns
KUBE_CLUSTER_DNS="192.168.22.2"
KUBE_CLUSTER_DOMAIN="cluster.local"

# etcd config
KUBE_ETCD_SERVICE_NAME="kube-etcd.service"
KUBE_ETCD_HOSTNAME="etcd"
KUBE_ETCD_NAME_PREFIX="etcd-"
KUBE_ETCD_DATA_DIR="/var/lib/etcd"
KUBE_ETCD_LISTEN_CLIENT_PORT="2379"
KUBE_ETCD_LISTEN_PEER_PORT="2380"
KUBE_ETCD_INITIAL_CLUSTER_STATE="new" #existing

# api server config
KUBE_APISERVER_SERVICE_NAME="kube-apiserver.service"
KUBE_APISERVER_HOSTNAME="apiserver"
KUBE_APISERVER_PORT="6443"

# scheduler config
KUBE_SCHEDULER_SERVICE_NAME="kube-scheduler.service"
KUBE_SCHEDULER_HOSTNAME="scheduler"

# controller_manager config
KUBE_CONTROLLER_MANAGE_SERVICE_NAME="kube-controller-manager.service"
KUBE_CONTROLLER_MANAGE_HOSTNAME="controller_manager"
KUBE_CONTROLLER_MANAGE_PORT="5443"

# kube node
KUBE_NODE_HOSTNAME="node"

# node kubelet config
KUBE_NODE_KUBELET_SERVICE_NAME="kube-kubelet.service"

# kube node proxy config
KUBE_NODE_PROXY_SERVICE_NAME="kube-proxy.service"

# kube node docker config
KUBE_NODE_DOCKER_SERVICE_NAME="kube-docker.service"

# kube calico config
KUBE_CALICO_ETC_PATH="/etc/calico"
KUBE_CALICOCTL_CONFIG_NAME="calicoctl.cfg"
KUBE_CALICONODE_CONFIG_NAME="calico.yaml"

# kube dns config
KUBE_DNS_ETC_PATH="/etc/kube-dns"
KUBE_DNS_CONFIG_NAME="kube-dns.yaml"
KUBE_DNS_AUTOSCALER_CONFIG_NAME="dns-horizontal-autoscaler.yaml"